%global githash 2cd932235358bee74468867285c98c5eacdcdaca
Name:          dozer
Version:       5.5.1
Release:       5%{?dist}
Summary:       Java Bean to Java Bean mapper
License:       ASL 2.0
URL:           http://dozer.sourceforge.net/
Source0:       https://github.com/DozerMapper/%{name}/archive/%{githash}.zip
# https://github.com/DozerMapper/dozer/issues/228
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-lang3
BuildRequires: bea-stax
BuildRequires: bea-stax-api
BuildRequires: felix-osgi-core
BuildRequires: felix-parent
BuildRequires: glassfish-el
BuildRequires: glassfish-el-api
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxb-api
BuildRequires: hibernate3
BuildRequires: junit
BuildRequires: jcl-over-slf4j
BuildRequires: protobuf-java
BuildRequires: slf4j
BuildRequires: slf4j-log4j12
BuildRequires: springframework
BuildRequires: springframework-context
BuildRequires: xmlbeans

# test deps
BuildRequires: cglib
BuildRequires: javassist
BuildRequires: mockito
BuildRequires: objectweb-asm3
BuildRequires: relaxngDatatype
BuildRequires: springframework-test
BuildRequires: xml-commons-apis

BuildRequires: jaxb2-maven-plugin
BuildRequires: maven-local
BuildRequires: maven-plugin-build-helper
BuildRequires: maven-plugin-bundle
BuildRequires: xmlbeans-maven-plugin

BuildArch:     noarch

%description
Dozer is a Java Bean to Java Bean mapper that recursively
copies data from one object to another. Typically, these
Java Beans will be of different complex types.

Dozer supports simple property mapping, complex type mapping,
bi-directional mapping, implicit-explicit mapping, as well as
recursive mapping. This includes mapping collection attributes
that also need mapping at the element level.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{githash}
find . -name "*.jar" -delete
find . -name "*.class" -delete

cp -p %{SOURCE1} LICENSE
sed -i 's/\r//' LICENSE

%pom_disable_module osgi
%pom_disable_module osgi-test
%pom_add_plugin org.apache.felix:maven-bundle-plugin . '
<extensions>true</extensions>
<configuration>
  <instructions>
    <Bundle-Name>${project.artifactId}</Bundle-Name>
    <Bundle-SymbolicName>${project.groupId}.${project.artifactId}</Bundle-SymbolicName>
    <Bundle-Description>${project.name}</Bundle-Description>
  </instructions>
</configuration>
<executions>
<execution>
  <id>bundle-manifest</id>
  <phase>process-classes</phase>
  <goals>
    <goal>manifest</goal>
  </goals>
</execution>
</executions>'

for p in core proto spring; do
%pom_xpath_set "pom:project/pom:packaging" bundle ${p}
# Unwanted
%pom_remove_plugin :maven-source-plugin ${p}
%pom_remove_plugin :maven-javadoc-plugin ${p}
%pom_remove_plugin :cobertura-maven-plugin ${p}
done

# Unavailable
%pom_remove_plugin :findbugs-maven-plugin core
%pom_remove_plugin :maven-pdf-plugin core

# org.apache.maven.wagon:wagon-ssh
%pom_xpath_remove "pom:build/pom:extensions"
%pom_remove_plugin :maven-site-plugin core

# fix deps aId:gId
%pom_xpath_set "pom:project/pom:dependencies/pom:dependency[pom:artifactId='asm']/pom:version" 3 core
%pom_xpath_set "pom:project/pom:dependencies/pom:dependency[pom:artifactId='hibernate-core']/pom:version" 3 core

%pom_remove_dep org.glassfish.web:el-impl core
%pom_add_dep org.glassfish.web:javax.el::provided core
%pom_remove_dep cglib:cglib-nodep core
%pom_add_dep net.sf.cglib:cglib::test core
%pom_remove_dep javax.xml.bind:jsr173_api core
%pom_add_dep stax:stax-api::provided core
%pom_xpath_set "pom:dependency[pom:groupId='javax.el']/pom:artifactId" javax.el-api core


# these test fails:
# Class org.dozer.util.ReflectionUtils can not access a member of
# class org.apache.xerces.jaxp.datatype.XMLGregorianCalendarImpl with modifiers "public"
# requires: com.sun.org.apache.xerces.internal.jaxp.datatype.XMLGregorianCalendarImpl
rm -r core/src/test/java/org/dozer/functional_tests/ConstructorTest.java \
 core/src/test/java/org/dozer/functional_tests/DateFormatTest.java

%build

# for eclipse plugin see https://github.com/DozerMapper/dozer/issues/209
# in near future should be in a separate project
# Disable test suite incompatibility with newer cglib
%mvn_build -f -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles
%doc README.md
%license LICENSE.md LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE.md LICENSE

%changelog
* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 5.5.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Jul 08 2016 gil cattaneo <puntogil@libero.it> 5.5.1-4
- disable test suite

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 5.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Jan 28 2015 gil cattaneo <puntogil@libero.it> 5.5.1-1
- update to 5.5.1

* Sat Jun 22 2013 gil cattaneo <puntogil@libero.it> 5.4.0-1
- initial rpm
